#include "Calculadora.frm"

/*
 * Evento OnCreate.
 */
METHOD CalculadoraOnCreate( oSender ) CLASS TCalculadora

   ::FLastInput := "NONE"
   ::FDecimalFlag := .F.
   ::FOpFlag := " "
   ::FNumOps := 0
   ::FOp1 := 0
   ::FOp2 := 0

return

/*
 * Evento OnClose.
 */
METHOD FormOnClose( oSender, nAction ) CLASS TCalculadora

   ::Position := poDesigned

return

/*
 * Evento OnKeyDown.
 */
METHOD DoKey( oSender, nKey ) CLASS TCalculadora

   do case
      case nKey == 67 .or. nKey == 99
         ::BotonC()

      case nKey == 48
         ::BotonClick( "0" )

      case nKey == 49
         ::BotonClick( "1" )

      case nKey == 50
         ::BotonClick( "2" )

      case nKey == 51
         ::BotonClick( "3" )

      case nKey == 52
         ::BotonClick( "4" )

      case nKey == 53
         ::BotonClick( "5" )

      case nKey == 54
         ::BotonClick( "6" )

      case nKey == 55
         ::BotonClick( "7" )

      case nKey == 56
         ::BotonClick( "8" )

      case nKey == 57
         ::BotonClick( "9" )

      case nKey == 42
         ::BotonOperador( "*" )

      case nKey == 47
         ::BotonOperador( "/" )

      case nKey == 43
         ::BotonOperador( "+" )

      case nKey == 45
         ::BotonOperador( "-" )

      case nKey == 46
         ::BotonPunto()

      case nKey == 37
         ::BotonPorciento()

      case nKey == VK_RETURN
         ::BotonOperador( "=" )

      case nKey == VK_BACK
         ::BotonCE()

      case nKey == VK_ESCAPE
         ::Close()
   endcase

   nKey := 0

return

/*
 * Evento OnClick.
 */
METHOD BotonClick7( oSender ) CLASS TCalculadora

   ::BotonClick( "7" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick8( oSender ) CLASS TCalculadora

   ::BotonClick( "8" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick9( oSender ) CLASS TCalculadora

   ::BotonClick( "9" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick4( oSender ) CLASS TCalculadora

   ::BotonClick( "4" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick5( oSender ) CLASS TCalculadora

   ::BotonClick( "5" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick6( oSender ) CLASS TCalculadora

   ::BotonClick( "6" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick1( oSender ) CLASS TCalculadora

   ::BotonClick( "1" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick2( oSender ) CLASS TCalculadora

   ::BotonClick( "2" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick3( oSender ) CLASS TCalculadora

   ::BotonClick( "3" )

return

/*
 * Evento OnClick.
 */
METHOD BotonClick0( oSender ) CLASS TCalculadora

   ::BotonClick( "0" )

return

/*
 * Evento OnClick.
 */
METHOD BotonPunto( oSender ) CLASS TCalculadora

   if ::FLastInput == "NEG"
      ::FDisplay:Caption := "-0,"
   elseif ::FLastInput != "NUMS"
      ::FDisplay:Caption := "0,"
   endif

   ::FDecimalFlag := .T.
   ::FLastInput := "NUMS"
   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD BotonC( oSender ) CLASS TCalculadora

   ::FDisplay:Caption := "0,"
   ::FError:Caption := ""
   ::FOp1 := 0
   ::FOp2 := 0
   ::FLastInput := "NONE"
   ::FDecimalFlag := .F.
   ::FOpFlag := " "
   ::FNumOps := 0
   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD BotonCE( oSender ) CLASS TCalculadora

   local lMenos, lPuntoFinal

   if ( lMenos := Left( ::FDisplay:Caption, 1 ) == "-" )
      ::FDisplay:Caption := SubStr( ::FDisplay:Caption, 2 )
   endif

   if ( lPuntoFinal := Right( ::FDisplay:Caption, 1 ) == "," )
      ::FDisplay:Caption := Left( ::FDisplay:Caption, Len( ::FDisplay:Caption ) - 1 )
   endif

   if !Empty( ::FDisplay:Caption )
      ::FDisplay:Caption := Left( ::FDisplay:Caption, Len( ::FDisplay:Caption ) - 1 )
   endif

   if lPuntoFinal
      ::FDisplay:Caption += ","
   endif

   if ::FDisplay:Caption == ","
      ::FDisplay:Caption := "0,"
      ::FDecimalFlag := .F.
   endif

   if lMenos
      ::FDisplay:Caption := "-" + ::FDisplay:Caption
   endif

   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD BotonOperadorMas( oSender ) CLASS TCalculadora

   ::BotonOperador( "+" )

return

/*
 * Evento OnClick.
 */
METHOD BotonOperadorMenos( oSender ) CLASS TCalculadora

   ::BotonOperador( "-" )

return

/*
 * Evento OnClick.
 */
METHOD BotonOperadorPor( oSender ) CLASS TCalculadora

   ::BotonOperador( "*" )

return

/*
 * Evento OnClick.
 */
METHOD BotonOperadorEntre( oSender ) CLASS TCalculadora

   ::BotonOperador( "/" )

return

/*
 * Evento OnClick.
 */
METHOD BotonOperadorIgual( oSender ) CLASS TCalculadora

   ::BotonOperador( "=" )

return

/*
 * Evento OnClick.
 */
METHOD BotonPorciento( oSender ) CLASS TCalculadora

   local nVal

   nVal := ::Valor( ::FDisplay:Caption ) / 100
   ::FDisplay:Caption := LTrim( Transform( nVal, "@E ################.########" ) )

   if At( ",", ::FDisplay:Caption ) == 0
      ::FDisplay:Caption += ","
   endif

   do while Right( ::FDisplay:Caption, 1 ) == "0"
      ::FDisplay:Caption := Left( ::FDisplay:Caption, Len( ::FDisplay:Caption ) - 1 )
   enddo

   if At( ",", ::FDisplay:Caption ) > 15
      ::FError:Caption := "E"
      ::FDisplay:Caption := "0,"
      ::FOp1 := 0
   endif

   ::FDisplay:Caption := Left( ::FDisplay:Caption, 16 )
   ::FLastInput := "OPS"
   ::FOpFlag := "%"
   ::FNumOps++
   ::FDecimalFlag := .T.
   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return

/*
 * Evento OnClick.
 */
METHOD BotonCopiar( oSender ) CLASS TCalculadora

   ::FEdit:Caption := ::FDisplay:Caption

   if Right( ::FEdit:Caption, 1 ) == ","
      ::FEdit:Caption := Left( ::FEdit:Caption, Len( ::FEdit:Caption ) - 1 )
   endif

   ::FEdit:SelStart := 0
   ::FEdit:SelLength := -1
   SendMessage( ::FEdit:Handle, WM_COPY, 0, 0 )
   ::FEdit:Caption := "       "
   ::Close()

return

/*
 * Convierte el valor del display en nmero.
 */
METHOD Valor( cDisplay ) CLASS TCalculadora

   local nPos

   nPos := At( ",", cDisplay )

   if nPos > 0
      cDisplay := Left( cDisplay, nPos - 1 ) + "." + SubStr( cDisplay, nPos + 1 )
   endif

return Val( cDisplay )

/*
 * Procesa un botn.
 */
METHOD BotonClick( cBoton ) CLASS TCalculadora

   if ::FLastInput != "NUMS"
      ::FDisplay:Caption := "0,"
      ::FDecimalFlag := .F.
   endif

   if Len( ::FDisplay:Caption ) < 16
      if ::FDecimalFlag
         ::FDisplay:Caption += cBoton
      else
         ::FDisplay:Caption := Left( ::FDisplay:Caption, Len( ::FDisplay:Caption ) - 1 ) + cBoton + ","
      endif

      do while Left( ::FDisplay:Caption, 1 ) == "0"
         if SubStr( ::FDisplay:Caption, 2, 1 ) == ","
            exit
         endif

         ::FDisplay:Caption := SubStr( ::FDisplay:Caption, 2 )
      enddo

      if ::FLastInput == "NEG"
         ::FDisplay:Caption := "-" + ::FDisplay:Caption
      endif
   endif

   ::FLastInput := "NUMS"
   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return

/*
 * Procesa un botn.
 */
METHOD BotonOperador( cOperador ) CLASS TCalculadora

   local cOldPantalla

   cOldPantalla := ::FDisplay:Caption

   if ::FLastInput == "NUMS"
      ::FNumOps += 1
   endif

   do case
      case ::FNumOps == 0
         if cOperador == "-" .and. ::FLastInput != "NEG"
            ::FDisplay:Caption := "-" + ::FDisplay:Caption
            ::FLastInput := "NEG"
         endif

      case ::FNumOps == 1
         ::FOp1 := ::Valor( ::FDisplay:Caption )

         if cOperador == "-" .and. ::FLastInput != "NUMS" .and. ::FOpFlag != "="
            ::FDisplay:Caption := "-"
            ::FLastInput := "NEG"
         endif

      case ::FNumOps == 2
         ::FOp2 := ::Valor( cOldPantalla )

         do case
            case ::FOpFlag == "+"
               ::FOp1 += ::FOp2

            case ::FOpFlag == "-"
               ::FOp1 -= ::FOp2

            case ::FOpFlag == "*"
               ::FOp1 *= ::FOp2

            case ::FOpFlag == "/"
               if ::FOp2 == 0
                  ::FError:Caption := "E"
                  ::FOp1 := 0
               else
                  ::FOp1 /= ::FOp2
               endif

            case ::FOpFlag == "="
               ::FOp1 := ::FOp2

            case ::FOpFlag == "%" .and. cOperador == "+"
               ::FOp1 += ::FOp1 * ::FOp2

            case ::FOpFlag == "%"
               ::FOp1 *= ::FOp2
         endcase

         ::FDisplay:Caption := LTrim( Transform( ::FOp1, "@E ################.########" ) )

         if At( ",", ::FDisplay:Caption ) == 0
            ::FDisplay:Caption += ","
         endif

         do while Right( ::FDisplay:Caption, 1 ) == "0"
            ::FDisplay:Caption := Left( ::FDisplay:Caption, Len( ::FDisplay:Caption ) - 1 )
         enddo

         if At( ",", ::FDisplay:Caption ) > 15
            ::FError:Caption := "E"
            ::FDisplay:Caption := "0,"
            ::FOp1 := 0
         endif

         ::FDisplay:Caption := Left( ::FDisplay:Caption, 16 )
         ::FNumOps := 1
   endcase

   if ::FLastInput != "NEG"
      ::FLastInput := "OPS"
      ::FOpFlag := cOperador
   endif

   ::FEdit:Caption := "       "
   ::FEdit:SetFocus()

return